<html><head><META http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>Projet de Compilation</title><meta content="DocBook XSL Stylesheets V1.50.0" name="generator"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="article"><div class="titlepage"><div><h1 class="title"><a name="N400001"></a>Projet de Compilation</h1></div><div><div class="author"><h3 class="author">Camille HUOT</h3></div></div><div><div class="author"><h3 class="author">Maxence COURTY</h3></div></div><div><p class="releaseinfo">Version finale du jeudi 27 juin 2002</p></div><div><div class="abstract"><p class="title"><b>R&eacute;sum&eacute;</b></p><p>
		Ce document est le rapport du projet de compilation de la Licence
		Informatique du D&eacute;partement Informatique de Luminy:
		"R&eacute;alisation d'un compilateur".
	</p></div></div><hr></div><div class="toc"><p><b>Table des mati&egrave;res</b></p><dl><dt><a href="#N40001E">Pr&eacute;sentation</a></dt><dt><a href="#N400025">La grammaire du langage L</a></dt><dt><a href="#N40005E">Les petits "plus" de notre compilateur</a></dt><dt><a href="#N40007E">Les petits "moins" de "compilo"</a></dt><dt><a href="#N400085">Traces de compilation et d'ex&eacute;cution</a></dt><dd><dl><dt><a href="#N400088">Un exemple complet</a></dt><dt><a href="#N40008D">Le code source en langage L</a></dt><dt><a href="#N400093">Le code produit par le compilateur</a></dt><dt><a href="#N40009B">Trace de l'ex&eacute;cution par la machine virtuelle</a></dt></dl></dd><dt><a href="#N4000A7">Mode d'emploi du compilateur et de la machine virtuelle</a></dt></dl></div><div class="sect1"><div class="titlepage"><div><h2 class="title" style="clear: both"><a name="N40001E"></a>Pr&eacute;sentation</h2></div></div><p>
		L'objet de ce projet est la r&eacute;alisation d'un compilateur pour traduire des programmes
		&eacute;crits dans un langage &agrave; d&eacute;finir. Le code produit par le compilateur sera interpr&eacute;t&eacute;
		par une machine virtuelle &agrave; pile.
	</p><p>
		Notre compilateur est &eacute;crit en C et le langage (appel&eacute; L pendant le reste de ce 
		document) source du compilateur est un m&eacute;lange de C (pour la syntaxe, plifi&eacute;e) et
		de pascal (pour la verbosit&eacute;, francis&eacute;e).
	</p></div><div class="sect1"><div class="titlepage"><div><h2 class="title" style="clear: both"><a name="N400025"></a>La grammaire du langage L</h2></div></div><p>programme &gt; { declaration }</p><p>declaration -&gt; type decl_var_glob { ',' decl_var_glob } ';' | FONCTION decl_fonction | ';'</p><p>decl_var_glob -&gt; IDENT [ '[' ENTIER ']' ]</p><p>declaration_fonction -&gt; IDENT [ PRENDS liste_arguments ] ';' bloc VOILA</p><p>type -&gt; TYPE_ENTIER</p><p>liste_arguments -&gt; type IDENT { ',' type IDENT }</p><p>bloc -&gt; { instruction }</p><p>instruction -&gt; instr_si | instr_tantque | instr_retour | appel | type IDENT { ',' IDENT ] ';'</p><p>instr_si -&gt; SI expression FAIT bloc [ SINON bloc ] VOILA</p><p>instr_tantque -&gt; TANTQUE expression FAIT bloc VOILA</p><p>instr_retour -&gt; RENVOIE [ expression ] ';'</p><p>appel -&gt; IDENT appel_suite | ';'</p><p>appel_suite -&gt; [ '[' expression ']' ] '=' expression | appel_fonction</p><p>appel_fonction -&gt; '(' [ liste_params ] ')'</p><p>liste_params -&gt; expression { ',' expression }</p><p>expression -&gt; conjonction { '|'  conjonction }</p><p>conjonction -&gt; comparaison { '&amp;' comparaison }</p><p>comparaison -&gt; arith { relation arith }</p><p>relation -&gt; EGALE | DIFFERENT | '&lt;' | INFERIEUR | '&gt;' | SUPERIEUR</p><p>arith -&gt; [ op_add ] terme { op_add terme }</p><p>terme -&gt; facteur { op_mul facteur }</p><p>facteur -&gt; IDENT facteur_suite | '(' expression ')' | ENTIER </p><p>facteur_suite -&gt; appel_fonction | '[' expression ']' | &oslash;</p><p>op_add -&gt; '+' | '-'</p><p>op_mul -&gt; '*' | '/' | '%'</p><p>
	La grammaire a &eacute;t&eacute; revue et corrig&eacute;e plusieurs fois (jusqu'&agrave; tr&egrave;s t&ocirc;t ce matin)
	avant d'&ecirc;tre "parfaite".
</p><p>
	Il a notamment fallu la factoriser pour &eacute;viter d'avoir une grammaire ambig&uuml;e.
</p></div><div class="sect1"><div class="titlepage"><div><h2 class="title" style="clear: both"><a name="N40005E"></a>Les petits "plus" de notre compilateur</h2></div></div><p>
		Notre compilateur "compilo" est tr&egrave;s proche des sp&eacute;cifications donn&eacute;es dans le sujet.
		Cependant quelques variantes valent la peine d'&ecirc;tre not&eacute;es:
		<div class="itemizedlist"><ul type="disc"><li><p>
		On peux noter que l'allocation des variables (globales, locales et tableaux) sont
		tout le temps initialis&eacute;es &agrave; 0.</p></li><li><p>
		Les fonctions sont "oblig&eacute;es" de renvoyer une valeur, c'est &agrave; dire que lorsqu'on 
		atteint la fin d'une fonction sans faire de "renvoie", ou bien si on atteint un
		"renvoie" sans valeur, la fonction renvoie 0.</p><p>
		Cela &eacute;vite de v&eacute;rifier si on essaye d'affecter une fonction qui ne renvoie rien &agrave;
		une variable.
		</p></li><li><p>
		Une instruction a &eacute;t&eacute; rajout&eacute;e &agrave; la liste fournie. Il s'agit de PUTC qui d&eacute;pile
		une valeur et affiche le caract&egrave;re ASCII correspondant.</p></li><li><p>
		Deux fonctions ont &eacute;t&eacute; rajout&eacute;es de base dans tous les programmes:
		<div class="itemizedlist"><ul type="round"><li><p>
			putc(entier): gr&acirc;ce &agrave; la nouvelle instruction PUTC, c'est la fonction de base
			qui l'utilise (affiche le caract&egrave;re sp&eacute;cifi&eacute; par le code ASCII d&eacute;cimal en argument)
			</p></li><li><p>
			ecrireln(entier): affiche l'entier puis va &agrave; la ligne
			</p></li></ul></div>
		On aurait pu bien s&ucirc;r rajouter moultes fonctions annexes mais &ccedil;a n'&eacute;tait pas
		le but du projet ...</p></li><li><p>
		La machine virtuelle d&eacute;tecte les d&eacute;passements de pile pour &eacute;viter le segmentation
		fault d'elle-m&ecirc;me.
		</p></li></ul></div>
	</p></div><div class="sect1"><div class="titlepage"><div><h2 class="title" style="clear: both"><a name="N40007E"></a>Les petits "moins" de "compilo"</h2></div></div><p>
		Apr&egrave;s avoir relu le sujet, il me semble que compilo ne contient pas de "moins" par
		rapport &agrave; ce qui est demand&eacute;, sauf peut-&ecirc;tre le fait qu'il ne contient pas
		beaucoup d'"extensions".
	</p><p>
		Nous comptions faire ce projet en JAVA au d&eacute;but. Mais apr&egrave;s m&ucirc;re r&eacute;flexion, 
		il s'est av&eacute;r&eacute; que l'objet n'intervenait pas dans ce projet, et que les syst&egrave;mes
		disponibles sous JAVA comme CUP (&eacute;quivalent de YACC) n'apportaient rien d'int&eacute;ressant.
	</p></div><div class="sect1"><div class="titlepage"><div><h2 class="title" style="clear: both"><a name="N400085"></a>Traces de compilation et d'ex&eacute;cution</h2></div></div><div class="sect2"><div class="titlepage"><div><h3 class="title"><a name="N400088"></a>Un exemple complet</h3></div></div><p>
			Plut&ocirc;t que de montrer plusieurs petits programmes, voici un programme complet
			qui utilise beaucoup des fonctionnalit&eacute;s du compilateur (tableau, variables locales et
			globales, appel de fonction, r&eacute;cursivit&eacute;, utilisation des fonctions pr&eacute;-&eacute;crites, boucles,
			conditions, valeurs de retour et quelques op&eacute;rations).
		</p></div><div class="sect2"><div class="titlepage"><div><h3 class="title"><a name="N40008D"></a>Le code source en langage L</h3></div></div><pre class="programlisting">
entier t[10];

fonction init;
        t[0] = 34;
        t[1] = 5;
        t[2] = 67;
        t[3] = 34;
        t[4] = -3;
        t[5] = -7;
        t[6] = 1;
        t[7] = 0;
        t[8] = 5;
        t[9] = -3;
voila

fonction tri;
        entier i, j;
        entier temp;

        tantque i&lt;10 fait
                j=0;
                tantque j&lt;(9-i) fait
                        si t[j] &gt; t[j+1] fait
                                temp=t[j];
                                t[j]=t[j+1];
                                t[j+1]=temp;
                        voila
                        j=j+1;
                voila
                i=i+1;
        voila
voila

fonction recherche prends entier a, entier deb, entier fin;
        si a &lt; t[(deb+fin)/2] fait
                renvoie recherche(a, deb, (deb+fin)/2);
        sinon 
                si a &gt; t[(deb+fin)/2] fait
                        renvoie recherche(a, (deb+fin)/2, fin);
                sinon
                        renvoie (deb+fin)/2;
                voila
        voila
voila

fonction affiche_tab;
        entier i;
        i=0;
        tantque i&lt;10 fait
                ecrire(i);
                putc(32);
                ecrire(t[i]);
                putc(10);
                i=i+1;
        voila
        putc(45);
        putc(45);
        putc(45);
        putc(10);
voila

fonction debut;
        init();
        affiche_tab();
        tri();
        affiche_tab();
        entier a;
        a = lire();
        ecrireln(recherche(a,0,9));
voila
</pre></div><div class="sect2"><div class="titlepage"><div><h3 class="title"><a name="N400093"></a>Le code produit par le compilateur</h3></div></div><p>Note: les instructions sont remplac&eacute;es par leur nom pour une meilleure lisibilit&eacute;</p><pre class="programlisting">
   0 ENTREE
   1 EMPL -3
   3 ECRIV
   4 SORTIE
   5 RETOUR
   6 ENTREE
   7 LIRE
   8 DEPL -3
  10 SORTIE
  11 RETOUR
  12 ENTREE
  13 EMPL -3
  15 PUTC
  16 SORTIE
  17 RETOUR
  18 ENTREE
  19 EMPL -3
  21 ECRIV
  22 EMPC 10
  24 PUTC
  25 SORTIE
  26 RETOUR
  27 ENTREE
  28 EMPC 0
  30 EMPC 34
  32 DEPT 0
  34 EMPC 1
  36 EMPC 5
  38 DEPT 0
  40 EMPC 2
  42 EMPC 67
  44 DEPT 0
  46 EMPC 3
  48 EMPC 34
  50 DEPT 0
  52 EMPC 4
  54 EMPC 0
  56 EMPC 3
  58 SOUS
  59 DEPT 0
  61 EMPC 5
  63 EMPC 0
  65 EMPC 7
  67 SOUS
  68 DEPT 0
  70 EMPC 6
  72 EMPC 1
  74 DEPT 0
  76 EMPC 7
  78 EMPC 0
  80 DEPT 0
  82 EMPC 8
  84 EMPC 5
  86 DEPT 0
  88 EMPC 9
  90 EMPC 0
  92 EMPC 3
  94 SOUS
  95 DEPT 0
  97 SORTIE
  98 RETOUR
-------------------
  99 ENTREE
 100 EMPC 0
 102 EMPC 0
 104 EMPC 0
 106 EMPL 0
 108 EMPC 10
 110 INF
 111 SIFAUX 186
 113 EMPC 0
 115 DEPL 1
 117 EMPL 1
 119 EMPC 9
 121 EMPL 0
 123 SOUS
 124 INF
 125 SIFAUX 177
 127 EMPL 1
 129 EMPT 0
 131 EMPL 1
 133 EMPC 1
 135 ADD
 136 EMPT 0
 138 INFEG
 139 NON
 140 SIFAUX 168
 142 EMPL 1
 144 EMPT 0
 146 DEPL 2
 148 EMPL 1
 150 EMPL 1
 152 EMPC 1
 154 ADD
 155 EMPT 0
 157 DEPT 0
 159 EMPL 1
 161 EMPC 1
 163 ADD
 164 EMPL 2
 166 DEPT 0
 168 EMPL 1
 170 EMPC 1
 172 ADD
 173 DEPL 1
 175 SAUT 117
 177 EMPL 0
 179 EMPC 1
 181 ADD
 182 DEPL 0
 184 SAUT 106
 186 SORTIE
 187 RETOUR
-------------------
 188 ENTREE
 189 EMPL -5
 191 EMPL -4
 193 EMPL -3
 195 ADD
 196 EMPC 2
 198 DIV
 199 EMPT 0
 201 INF
 202 SIFAUX 228
 204 EMPC 0
 206 EMPL -5
 208 EMPL -4
 210 EMPL -4
 212 EMPL -3
 214 ADD
 215 EMPC 2
 217 DIV
 218 APPEL 188
 220 PILE -3
 222 DEPL -6
 224 SORTIE
 225 RETOUR
 226 SAUT 280
 228 EMPL -5
 230 EMPL -4
 232 EMPL -3
 234 ADD
 235 EMPC 2
 237 DIV
 238 EMPT 0
 240 INFEG
 241 NON
 242 SIFAUX 268
 244 EMPC 0
 246 EMPL -5
 248 EMPL -4
 250 EMPL -3
 252 ADD
 253 EMPC 2
 255 DIV
 256 EMPL -3
 258 APPEL 188
 260 PILE -3
 262 DEPL -6
 264 SORTIE
 265 RETOUR
 266 SAUT 280
 268 EMPL -4
 270 EMPL -3
 272 ADD
 273 EMPC 2
 275 DIV
 276 DEPL -6
 278 SORTIE
 279 RETOUR
 280 SORTIE
 281 RETOUR
-------------------
 282 ENTREE
 283 EMPC 0
 285 EMPC 0
 287 DEPL 0
 289 EMPL 0
 291 EMPC 10
 293 INF
 294 SIFAUX 347
 296 EMPC 0
 298 EMPL 0
 300 APPEL 0
 302 PILE -1
 304 PILE -1
 306 EMPC 0
 308 EMPC 32
 310 APPEL 12
 312 PILE -1
 314 PILE -1
 316 EMPC 0
 318 EMPL 0
 320 EMPT 0
 322 APPEL 0
 324 PILE -1
 326 PILE -1
 328 EMPC 0
 330 EMPC 10
 332 APPEL 12
 334 PILE -1
 336 PILE -1
 338 EMPL 0
 340 EMPC 1
 342 ADD
 343 DEPL 0
 345 SAUT 289
 347 EMPC 0
 349 EMPC 45
 351 APPEL 12
 353 PILE -1
 355 PILE -1
 357 EMPC 0
 359 EMPC 45
 361 APPEL 12
 363 PILE -1
 365 PILE -1
 367 EMPC 0
 369 EMPC 45
 371 APPEL 12
 373 PILE -1
 375 PILE -1
 377 EMPC 0
 379 EMPC 10
 381 APPEL 12
 383 PILE -1
 385 PILE -1
 387 SORTIE
 388 RETOUR
-------------------
 389 SAUT 392
 391 STOP
 392 EMPC 391
 394 ENTREE
 395 EMPC 0
 397 APPEL 27
 399 PILE -1
 401 EMPC 0
 403 APPEL 282
 405 PILE -1
 407 EMPC 0
 409 APPEL 99
 411 PILE -1
 413 EMPC 0
 415 APPEL 282
 417 PILE -1
 419 EMPC 0
 421 EMPC 0
 423 APPEL 6
 425 DEPL 0
 427 EMPC 0
 429 EMPC 0
 431 EMPL 0
 433 EMPC 0
 435 EMPC 9
 437 APPEL 188
 439 PILE -3
 441 APPEL 18
 443 PILE -1
 445 PILE -1
 447 STOP
</pre></div><div class="sect2"><div class="titlepage"><div><h3 class="title"><a name="N40009B"></a>Trace de l'ex&eacute;cution par la machine virtuelle</h3></div></div><pre class="screen">
0 34
1 5
2 67
3 34
4 -3
5 -7
6 1
7 0
8 5
9 -3
---
0 -7
1 -3
2 -3
3 0
4 1
5 5
6 5
7 34
8 34
9 67
---
5
6
</pre><p>
	La premi&egrave;re s&eacute;rie affiche le tableau initialis&eacute; &agrave; la main avec des valeurs quelconques.
</p><p>
	La deuxi&egrave;me s&eacute;rie montre le m&ecirc;me tableau apr&egrave;s &ecirc;tre pass&eacute; par la fonction tri, qui
	utilise pleinement les affectations de tableaux, variables, compteurs et les boucles.
</p><p>
	Ensuite le programme demande un nombre &agrave; chercher dans la liste, ici j'ai entr&eacute; la valeur
	5. La fonction recherche (c'est une recherche dichotomique) est lanc&eacute;e (elle utilise la r&eacute;cursivit&eacute;,
	les arguments de fonctions, les valeurs de retour, et les si, si/sinon) et affiche l'indice du
	tableau qui contient la valeur 5.
</p></div></div><div class="sect1"><div class="titlepage"><div><h2 class="title" style="clear: both"><a name="N4000A7"></a>Mode d'emploi du compilateur et de la machine virtuelle</h2></div></div><p>
	Leur utilisation est tr&egrave;s simple, il n'y a pas d'options possibles. En g&eacute;n&eacute;ral on donne une liste
	de fichiers *.xam &agrave; compiler &agrave; <tt>compilo</tt> et le compilateur g&eacute;n&egrave;re les fichiers
	*.mac correspondants. Pour la machine virtuelle, on sp&eacute;cifie un fichier *.mac (l'extension importe
	peu) en argument et celui-ci se trouve ex&eacute;cut&eacute;.
</p></div></div></body></html>